'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('babel-polyfill');

var _fsPromise = require('fs-promise');

var _fs = require('fs');

var _babelCore = require('babel-core');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _mkdirpThen = require('mkdirp-then');

var _mkdirpThen2 = _interopRequireDefault(_mkdirpThen);

var _broccoliPlugin = require('broccoli-plugin');

var _broccoliPlugin2 = _interopRequireDefault(_broccoliPlugin);

var _walkSync = require('walk-sync');

var _walkSync2 = _interopRequireDefault(_walkSync);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Broccoli plugin that transpiles es2015 code to es5 using Babel of version 6.
 */

var Babel = function (_Plugin) {
  _inherits(Babel, _Plugin);

  /**
   * Creates a new Babel plugin instance. For more info see
   * {@link https://github.com/broccolijs/broccoli-plugin}
   *
   * @param {Node|Node[]} inputNodes List of input nodes
   * @param {Object} options Plugin options
   */

  function Babel(inputNodes) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    _classCallCheck(this, Babel);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Babel).call(this, Array.isArray(inputNodes) ? inputNodes : [inputNodes], {
      name: 'Babel',
      persistentOutput: options.persistentOutput ? options.persistentOutput : false
    }));

    delete options.persistentOutput;

    if (Object.getOwnPropertyNames(options).length === 0) {
      options = JSON.parse((0, _fs.readFileSync)(_path2.default.join(process.cwd(), '.babelrc'), 'utf8'));
    }

    /**
     * Plugin options. Equal to Babel options
     * {@link https://babeljs.io/docs/usage/options/}
     *
     * @type {Object}
     */
    _this.options = options;
    return _this;
  }

  /**
   * Builds received nodes.
   *
   * Walks over all files in the directory, asynchronously reads it, compiles
   * through babel and writes the compiled data to the output folder.
   */


  _createClass(Babel, [{
    key: 'build',
    value: function () {
      var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
        var _inputPaths, inputPath, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, fname, code, output, outputFilename;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _inputPaths = _slicedToArray(this.inputPaths, 1);
                inputPath = _inputPaths[0];
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context.prev = 5;
                _iterator = (0, _walkSync2.default)(inputPath)[Symbol.iterator]();

              case 7:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context.next = 23;
                  break;
                }

                fname = _step.value;

                if (!(fname.slice(-3) !== '.js')) {
                  _context.next = 11;
                  break;
                }

                return _context.abrupt('continue', 20);

              case 11:
                _context.next = 13;
                return (0, _fsPromise.readFile)(inputPath + '/' + fname, 'utf8');

              case 13:
                code = _context.sent;
                output = (0, _babelCore.transform)(code, this.options);
                outputFilename = this.outputPath + '/' + fname;
                _context.next = 18;
                return (0, _mkdirpThen2.default)(_path2.default.dirname(outputFilename));

              case 18:
                _context.next = 20;
                return (0, _fsPromise.writeFile)(outputFilename, output.code);

              case 20:
                _iteratorNormalCompletion = true;
                _context.next = 7;
                break;

              case 23:
                _context.next = 29;
                break;

              case 25:
                _context.prev = 25;
                _context.t0 = _context['catch'](5);
                _didIteratorError = true;
                _iteratorError = _context.t0;

              case 29:
                _context.prev = 29;
                _context.prev = 30;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 32:
                _context.prev = 32;

                if (!_didIteratorError) {
                  _context.next = 35;
                  break;
                }

                throw _iteratorError;

              case 35:
                return _context.finish(32);

              case 36:
                return _context.finish(29);

              case 37:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[5, 25, 29, 37], [30,, 32, 36]]);
      }));

      function build() {
        return ref.apply(this, arguments);
      }

      return build;
    }()
  }]);

  return Babel;
}(_broccoliPlugin2.default);

exports.default = Babel;
module.exports = exports['default'];